#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")

	//SDLpݒ
	#pragma comment(lib, "SDL.lib")
	#pragma comment(lib, "SDLmain.lib")
	//C/C++R[h^CCu}`XbhDLLɕύX
#endif

#include <SDL/SDL.h> 
#include <SDL/SDL_syswm.h>//SysWMinfogp

#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;


//L[Cxg
int keyFunc(IrrlichtDevice *device) 
{ 
	SDL_Event event;
	//if(SDL_WaitEvent(&event))//҂
	if(SDL_PollEvent(&event))//
	{
		switch(event.type)
		{
			case SDL_QUIT:
				device->closeDevice();
				break;
			//L[{[h
			case SDL_KEYDOWN:
			{
				switch(event.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						device->closeDevice();
						break;
				}
			}
			break;
		}
	}

	return 0;
}

//SDLpfoCX쐬
IrrlichtDevice* createDeviceSDL
(
	video::E_DRIVER_TYPE deviceType,
	const core::dimension2d<s32> & windowSize,
	u32 bits,
	bool fullscreen,
	bool stencilbuffer,
	bool vsync,
	IEventReceiver* receiver,
	const c8* sdk_version_do_not_use)
{
	//SDLtO(ɂďĂ)
	u32 flags = SDL_HWSURFACE|SDL_DOUBLEBUF;
	if(fullscreen)
		flags |= SDL_FULLSCREEN;

	//SDL̏
	if(SDL_Init(SDL_INIT_EVERYTHING) < 0)
		return 0;

	//vOǏĂяo֐w
	atexit(SDL_Quit);

	//SDLrfI\̏
	if(SDL_SetVideoMode(windowSize.Width, windowSize.Height, bits, flags) == 0)
		return 0;

	//L[s[gL(50ms)
	SDL_EnableKeyRepeat(50,50);

	//L[UnicodeϊL
	SDL_EnableUNICODE(1);

	//SDLVXe擾(WindoIDp)
	SDL_SysWMinfo wmInfo;			//VXe擾p\
	SDL_VERSION(&wmInfo.version);	//VXever擾
	SDL_GetWMInfo(&wmInfo);			//verEChE擾

	//p[^쐬
	SIrrlichtCreationParameters param;
	param.AntiAlias     = false;
	param.Bits          = bits;
	param.DriverType    = deviceType;//EDT_OPENGL;
	param.Fullscreen    = fullscreen;
	param.Stencilbuffer = stencilbuffer;
	param.Vsync         = vsync;
	param.WindowSize    = windowSize;
	param.WindowId      = wmInfo.window;//SDL̃EChEnhw

	IrrlichtDevice *device = createDeviceEx(param);

	//V[oݒ
	device->setEventReceiver(receiver);

	return device;
}

#ifdef WIN32
	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
#else
	int main()
#endif
{
	IrrlichtDevice *device = createDeviceSDL(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,false,0,0);

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	IVideoDriver* driver = device->getVideoDriver();
	ISceneManager* smgr  = device->getSceneManager();

	while(device->run())
	{
		driver->beginScene(true, true, 0xFF6060FF);

		//L[
		keyFunc(device);

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	device->drop();

	return 0;
}
